//                                                                  
// Copyright  2007-2009 Lidor Systems.
// All Rights Reserved.
//
// This file is part of the "IntegralUI Lists" class Library. 
//                                                                   
// The contents of this file are subject to the IntegralUI ListView
// License, and may not be used except in compliance with the License.
// A copy of the License should have been installed in the product's
// root installation directory or it can be found at
// http://www.lidorsystems.com/products/IntegralUI/agreement_listview.aspx.
//                                                             
// This SOFTWARE is provided "AS IS", WITHOUT WARRANTY OF ANY KIND.
// either express or implied. See the License for the specific language 
// governing rights and limitations under the License.                        
//

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace IntegralUIListViewImageScaling
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		#region Variables
		private System.Windows.Forms.Panel panel1;
		private LidorSystems.IntegralUI.Lists.ListView listView1;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.ImageList imageList2;
		private System.Windows.Forms.ImageList imageList3;
		private System.Windows.Forms.CheckBox cbCheckBoxes;
		private System.Windows.Forms.CheckBox cbFlags;
		private System.Windows.Forms.ImageList imageList4;
		private System.Windows.Forms.CheckBox cbFading;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.ComboBox cbSpeed;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.NumericUpDown numSpacing;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TrackBar ctrlScale;
		private System.Windows.Forms.Label label7;
		private System.ComponentModel.IContainer components;
		#endregion

		#region Construction
		public Form1()
		{
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            LidorSystems.IntegralUI.Lists.Style.ListItemColorStyle listItemColorStyle1 = new LidorSystems.IntegralUI.Lists.Style.ListItemColorStyle();
            LidorSystems.IntegralUI.Lists.Style.ListItemFormatStyle listItemFormatStyle1 = new LidorSystems.IntegralUI.Lists.Style.ListItemFormatStyle();
            LidorSystems.IntegralUI.Style.ScrollBarStyle scrollBarStyle1 = new LidorSystems.IntegralUI.Style.ScrollBarStyle();
            LidorSystems.IntegralUI.Style.WatermarkImage watermarkImage1 = new LidorSystems.IntegralUI.Style.WatermarkImage();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.panel1 = new System.Windows.Forms.Panel();
            this.panel2 = new System.Windows.Forms.Panel();
            this.label7 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.ctrlScale = new System.Windows.Forms.TrackBar();
            this.label6 = new System.Windows.Forms.Label();
            this.numSpacing = new System.Windows.Forms.NumericUpDown();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.label5 = new System.Windows.Forms.Label();
            this.cbSpeed = new System.Windows.Forms.ComboBox();
            this.cbFading = new System.Windows.Forms.CheckBox();
            this.cbFlags = new System.Windows.Forms.CheckBox();
            this.cbCheckBoxes = new System.Windows.Forms.CheckBox();
            this.listView1 = new LidorSystems.IntegralUI.Lists.ListView();
            this.imageList2 = new System.Windows.Forms.ImageList(this.components);
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.imageList4 = new System.Windows.Forms.ImageList(this.components);
            this.imageList3 = new System.Windows.Forms.ImageList(this.components);
            this.panel1.SuspendLayout();
            this.panel2.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.ctrlScale)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.numSpacing)).BeginInit();
            this.groupBox1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.listView1)).BeginInit();
            this.SuspendLayout();
            // 
            // panel1
            // 
            this.panel1.Controls.Add(this.panel2);
            this.panel1.Controls.Add(this.label6);
            this.panel1.Controls.Add(this.numSpacing);
            this.panel1.Controls.Add(this.groupBox1);
            this.panel1.Controls.Add(this.cbFlags);
            this.panel1.Controls.Add(this.cbCheckBoxes);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Right;
            this.panel1.Location = new System.Drawing.Point(472, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(136, 374);
            this.panel1.TabIndex = 0;
            // 
            // panel2
            // 
            this.panel2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.panel2.Controls.Add(this.label7);
            this.panel2.Controls.Add(this.label4);
            this.panel2.Controls.Add(this.label3);
            this.panel2.Controls.Add(this.label2);
            this.panel2.Controls.Add(this.label1);
            this.panel2.Controls.Add(this.ctrlScale);
            this.panel2.Location = new System.Drawing.Point(4, 12);
            this.panel2.Name = "panel2";
            this.panel2.Size = new System.Drawing.Size(128, 200);
            this.panel2.TabIndex = 11;
            // 
            // label7
            // 
            this.label7.AutoSize = true;
            this.label7.Location = new System.Drawing.Point(36, 64);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(63, 13);
            this.label7.TabIndex = 10;
            this.label7.Text = "Large Icons";
            // 
            // label4
            // 
            this.label4.AutoSize = true;
            this.label4.Location = new System.Drawing.Point(36, 16);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(61, 13);
            this.label4.TabIndex = 9;
            this.label4.Text = "Extra Large";
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Location = new System.Drawing.Point(36, 176);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(61, 13);
            this.label3.TabIndex = 8;
            this.label3.Text = "Small Icons";
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Location = new System.Drawing.Point(36, 144);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(29, 13);
            this.label2.TabIndex = 7;
            this.label2.Text = "Tiles";
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(36, 108);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(73, 13);
            this.label1.TabIndex = 6;
            this.label1.Text = "Medium Icons";
            // 
            // ctrlScale
            // 
            this.ctrlScale.Location = new System.Drawing.Point(8, 8);
            this.ctrlScale.Maximum = 256;
            this.ctrlScale.Name = "ctrlScale";
            this.ctrlScale.Orientation = System.Windows.Forms.Orientation.Vertical;
            this.ctrlScale.Size = new System.Drawing.Size(45, 188);
            this.ctrlScale.TabIndex = 5;
            this.ctrlScale.TickStyle = System.Windows.Forms.TickStyle.None;
            this.ctrlScale.Value = 128;
            this.ctrlScale.Scroll += new System.EventHandler(this.ctrlScale_Scroll);
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Location = new System.Drawing.Point(8, 268);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(69, 13);
            this.label6.TabIndex = 10;
            this.label6.Text = "Item Spacing";
            // 
            // numSpacing
            // 
            this.numSpacing.Location = new System.Drawing.Point(80, 264);
            this.numSpacing.Name = "numSpacing";
            this.numSpacing.Size = new System.Drawing.Size(52, 20);
            this.numSpacing.TabIndex = 9;
            this.numSpacing.Value = new decimal(new int[] {
            1,
            0,
            0,
            0});
            this.numSpacing.ValueChanged += new System.EventHandler(this.numSpacing_ValueChanged);
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.label5);
            this.groupBox1.Controls.Add(this.cbSpeed);
            this.groupBox1.Controls.Add(this.cbFading);
            this.groupBox1.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.groupBox1.Location = new System.Drawing.Point(4, 292);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(128, 76);
            this.groupBox1.TabIndex = 8;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Fadding Effect";
            // 
            // label5
            // 
            this.label5.AutoSize = true;
            this.label5.Location = new System.Drawing.Point(4, 48);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(38, 13);
            this.label5.TabIndex = 9;
            this.label5.Text = "Speed";
            // 
            // cbSpeed
            // 
            this.cbSpeed.Enabled = false;
            this.cbSpeed.Items.AddRange(new object[] {
            "Very Slow",
            "Slow",
            "Normal",
            "Fast",
            "Very Fast"});
            this.cbSpeed.Location = new System.Drawing.Point(44, 44);
            this.cbSpeed.Name = "cbSpeed";
            this.cbSpeed.Size = new System.Drawing.Size(80, 21);
            this.cbSpeed.TabIndex = 8;
            this.cbSpeed.Text = "Normal";
            this.cbSpeed.SelectedIndexChanged += new System.EventHandler(this.cbSpeed_SelectedIndexChanged);
            // 
            // cbFading
            // 
            this.cbFading.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.cbFading.Location = new System.Drawing.Point(4, 20);
            this.cbFading.Name = "cbFading";
            this.cbFading.Size = new System.Drawing.Size(120, 16);
            this.cbFading.TabIndex = 7;
            this.cbFading.Text = "Office2007";
            this.cbFading.CheckedChanged += new System.EventHandler(this.cbFading_CheckedChanged);
            // 
            // cbFlags
            // 
            this.cbFlags.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.cbFlags.Location = new System.Drawing.Point(8, 240);
            this.cbFlags.Name = "cbFlags";
            this.cbFlags.Size = new System.Drawing.Size(120, 16);
            this.cbFlags.TabIndex = 6;
            this.cbFlags.Text = "Show Flags";
            this.cbFlags.CheckedChanged += new System.EventHandler(this.cbFlags_CheckedChanged);
            // 
            // cbCheckBoxes
            // 
            this.cbCheckBoxes.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.cbCheckBoxes.Location = new System.Drawing.Point(8, 220);
            this.cbCheckBoxes.Name = "cbCheckBoxes";
            this.cbCheckBoxes.Size = new System.Drawing.Size(120, 16);
            this.cbCheckBoxes.TabIndex = 5;
            this.cbCheckBoxes.Text = "Show Checkboxes";
            this.cbCheckBoxes.CheckedChanged += new System.EventHandler(this.cbCheckBoxes_CheckedChanged);
            // 
            // listView1
            // 
            // 
            // 
            // 
            this.listView1.ContentPanel.BackColor = System.Drawing.Color.Transparent;
            this.listView1.ContentPanel.Location = new System.Drawing.Point(3, 3);
            this.listView1.ContentPanel.Name = "";
            this.listView1.ContentPanel.Size = new System.Drawing.Size(466, 368);
            this.listView1.ContentPanel.TabIndex = 3;
            this.listView1.ContentPanel.TabStop = false;
            this.listView1.Cursor = System.Windows.Forms.Cursors.Default;
            this.listView1.Dock = System.Windows.Forms.DockStyle.Fill;
            listItemColorStyle1.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(230)))), ((int)(((byte)(147)))));
            listItemColorStyle1.BorderColor = System.Drawing.Color.FromArgb(((int)(((byte)(210)))), ((int)(((byte)(183)))), ((int)(((byte)(108)))));
            this.listView1.HoverItemStyle = listItemColorStyle1;
            this.listView1.ImageList = this.imageList2;
            listItemFormatStyle1.ImageSize = new System.Drawing.Size(98, 120);
            listItemFormatStyle1.Padding = new System.Windows.Forms.Padding(2, 7, 2, 2);
            listItemFormatStyle1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            this.listView1.ItemFormatStyle = listItemFormatStyle1;
            this.listView1.LargeImageList = this.imageList1;
            this.listView1.Location = new System.Drawing.Point(0, 0);
            this.listView1.Name = "listView1";
            scrollBarStyle1.ButtonFillStyle = LidorSystems.IntegralUI.Style.FillStyle.Horizontal;
            this.listView1.ScrollBarStyle = scrollBarStyle1;
            this.listView1.Size = new System.Drawing.Size(472, 374);
            this.listView1.StateImageList = this.imageList4;
            this.listView1.TabIndex = 1;
            this.listView1.Text = "listView1";
            this.listView1.TextLines = 2;
            this.listView1.View = LidorSystems.IntegralUI.Lists.ListViewAppearance.LargeIcon;
            this.listView1.WatermarkImage = watermarkImage1;
            // 
            // imageList2
            // 
            this.imageList2.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList2.ImageStream")));
            this.imageList2.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList2.Images.SetKeyName(0, "");
            // 
            // imageList1
            // 
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList1.Images.SetKeyName(0, "");
            this.imageList1.Images.SetKeyName(1, "");
            this.imageList1.Images.SetKeyName(2, "");
            this.imageList1.Images.SetKeyName(3, "");
            this.imageList1.Images.SetKeyName(4, "");
            this.imageList1.Images.SetKeyName(5, "");
            this.imageList1.Images.SetKeyName(6, "");
            this.imageList1.Images.SetKeyName(7, "");
            this.imageList1.Images.SetKeyName(8, "");
            this.imageList1.Images.SetKeyName(9, "");
            // 
            // imageList4
            // 
            this.imageList4.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList4.ImageStream")));
            this.imageList4.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList4.Images.SetKeyName(0, "");
            this.imageList4.Images.SetKeyName(1, "");
            this.imageList4.Images.SetKeyName(2, "");
            this.imageList4.Images.SetKeyName(3, "");
            this.imageList4.Images.SetKeyName(4, "");
            this.imageList4.Images.SetKeyName(5, "");
            this.imageList4.Images.SetKeyName(6, "");
            this.imageList4.Images.SetKeyName(7, "");
            this.imageList4.Images.SetKeyName(8, "");
            this.imageList4.Images.SetKeyName(9, "");
            // 
            // imageList3
            // 
            this.imageList3.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList3.ImageStream")));
            this.imageList3.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList3.Images.SetKeyName(0, "");
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(608, 374);
            this.Controls.Add(this.listView1);
            this.Controls.Add(this.panel1);
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "IntegralUI ListView - Scale Image Demo";
            this.Load += new System.EventHandler(this.Form1_Load);
            this.panel1.ResumeLayout(false);
            this.panel1.PerformLayout();
            this.panel2.ResumeLayout(false);
            this.panel2.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.ctrlScale)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.numSpacing)).EndInit();
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.listView1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		#region Initialization
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.listView1.SuspendUpdate();
			this.listView1.Items.Clear();

			LidorSystems.IntegralUI.Lists.ListViewItem item = null;
			for (int i = 0; i < 10; i++)
			{
				item = new LidorSystems.IntegralUI.Lists.ListViewItem("", 0, 0);
                item.Text = "Item " + i.ToString() + "\njpeg file";
//                item.LargeImageIndex = i;
                item.LargeImage = this.imageList1.Images[i];

				if (i % 2 == 0)
					item.StateImageIndex = i;

				this.listView1.Items.Add(item);
			}

			this.listView1.ResumeUpdate();
		}
		#endregion

		#region Methods
		private void ctrlScale_Scroll(object sender, System.EventArgs e)
		{
			this.listView1.SuspendUpdate();

			if (ctrlScale.Value > 48) 
			{
				if (this.listView1.CheckBoxes || this.listView1.ShowStateImages)
					this.listView1.ItemFormatStyle.Padding = new System.Windows.Forms.Padding(5, 7, 0, 2);
				else
					this.listView1.ItemFormatStyle.Padding = new System.Windows.Forms.Padding(0, 7, 0, 2);

				this.listView1.ItemFormatStyle.ImageScaleFactor = new Point((int)(ctrlScale.Value*100/128), (int)(ctrlScale.Value*100/128));
				this.listView1.View = LidorSystems.IntegralUI.Lists.ListViewAppearance.LargeIcon;
				this.listView1.ItemFormatStyle.TextAlign = ContentAlignment.MiddleCenter;

				UpdateItemText(3);
			}
			else if (ctrlScale.Value > 24 && ctrlScale.Value <= 48)
			{
				this.listView1.ItemFormatStyle.Padding = new System.Windows.Forms.Padding(2);
				this.listView1.ItemFormatStyle.ImageScaleFactor = new Point((int)(ctrlScale.Value*100/48), (int)(ctrlScale.Value*100/48));
				this.listView1.ImageList = this.imageList2;
				this.listView1.View = LidorSystems.IntegralUI.Lists.ListViewAppearance.List;
				this.listView1.ItemFormatStyle.TextAlign = ContentAlignment.MiddleLeft;

				if (ctrlScale.Value < 32)
					UpdateItemText(2);
				else
					UpdateItemText(1);
			}
			else if (ctrlScale.Value >= 16)
			{
				this.listView1.ItemFormatStyle.Padding = new System.Windows.Forms.Padding(2);
				this.listView1.ItemFormatStyle.ImageScaleFactor = new Point((int)(ctrlScale.Value*100/16), (int)(ctrlScale.Value*100/16));
				this.listView1.ImageList = this.imageList3;
				this.listView1.View = LidorSystems.IntegralUI.Lists.ListViewAppearance.List;
				this.listView1.ItemFormatStyle.TextAlign = ContentAlignment.MiddleLeft;

				UpdateItemText(0);
			}

			this.listView1.ResumeUpdate();
		}

		private void UpdateItemText(int textType)
		{
			switch (textType)
			{
				case 0:
                    for (int i = 0; i < this.listView1.Items.Count; i++)
                    {
                        this.listView1.Items[i].Content = String.Empty;
                        this.listView1.Items[i].Text = "Item " + i.ToString();
                    }
					break;

				case 1:
					for (int i = 0; i < this.listView1.Items.Count; i++)
                        this.listView1.Items[i].Content = "<div>Item " + i.ToString() + "<br></br><font color=\"Gray\">" + this.listView1.ImageList.Images[0].Width.ToString() + " x " + this.listView1.ImageList.Images[0].Height.ToString() + "<br></br>jpeg file</font></div>";
					break;

                case 2:
                    for (int i = 0; i < this.listView1.Items.Count; i++)
                        this.listView1.Items[i].Content = "<div>Item " + i.ToString() + "<br></br><font color=\"Gray\">jpeg file</font></div>";
                    break;
                
                case 3:
                    for (int i = 0; i < this.listView1.Items.Count; i++)
                    {
                        this.listView1.Items[i].Content = String.Empty;
                        this.listView1.Items[i].Text = "Item " + i.ToString() + "\njpeg file";
                    }
					break;
			}
		}


		private void cbCheckBoxes_CheckedChanged(object sender, System.EventArgs e)
		{
			this.listView1.CheckBoxes = cbCheckBoxes.Checked;

			if (this.listView1.CheckBoxes || this.listView1.ShowStateImages)
				this.listView1.ItemFormatStyle.Padding = new System.Windows.Forms.Padding(5, 7, 0, 2);
			else
				this.listView1.ItemFormatStyle.Padding = new System.Windows.Forms.Padding(0, 7, 0, 2);
		}

		private void cbFlags_CheckedChanged(object sender, System.EventArgs e)
		{
			this.listView1.ShowStateImages = cbFlags.Checked;

			if (this.listView1.CheckBoxes || this.listView1.ShowStateImages)
				this.listView1.ItemFormatStyle.Padding = new System.Windows.Forms.Padding(5, 7, 0, 2);
			else
				this.listView1.ItemFormatStyle.Padding = new System.Windows.Forms.Padding(0, 7, 0, 2);
		}

		private void cbFading_CheckedChanged(object sender, System.EventArgs e)
		{
			cbSpeed.Enabled = cbFading.Checked;

			if (cbFading.Checked)
				this.listView1.FadingEffect = LidorSystems.IntegralUI.FadingEffect.Office2007;
			else
				this.listView1.FadingEffect = LidorSystems.IntegralUI.FadingEffect.Default;
		}

		private void cbSpeed_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			switch (cbSpeed.SelectedIndex)
			{
				case 0:
					this.listView1.FadingSpeed = LidorSystems.IntegralUI.FadingSpeed.VerySlow; 
					break;
				case 1:
					this.listView1.FadingSpeed = LidorSystems.IntegralUI.FadingSpeed.Slow; 
					break;
				case 3:
					this.listView1.FadingSpeed = LidorSystems.IntegralUI.FadingSpeed.Fast; 
					break;
				case 4:
					this.listView1.FadingSpeed = LidorSystems.IntegralUI.FadingSpeed.VeryFast; 
					break;
				default:
					this.listView1.FadingSpeed = LidorSystems.IntegralUI.FadingSpeed.Normal; 
					break;
			}
		}

		private void numSpacing_ValueChanged(object sender, System.EventArgs e)
		{
			this.listView1.ItemSpacing = (int)numSpacing.Value;
		}
		#endregion
	}
}
